

package com.ravet.ideaplugins.linemover;


import com.intellij.openapi.editor.actionSystem.EditorAction;
import com.intellij.openapi.editor.actionSystem.EditorActionHandler;

public class BaseLineMover extends EditorAction {

	public BaseLineMover(EditorActionHandler i_editorActionHandler) {
		super(i_editorActionHandler);
	}

	/** Return a string from characters start (inclusive) to end (exclusive). */
	protected static String getString(char[] chars, int start, int end) {
		return String.valueOf(chars, start, end - start);
	}

	//
	// debug methods
	//

	/** Display the start and end chars of a block. */
	protected static void displayBlock(char[] document, int start, int end) {
		final int length = document.length;

		System.out.print('>');
		if (start - 2 >= 0) printChar(document[start - 2]);
		if (start - 1 >= 0) printChar(document[start - 1]);
		printChar(document[start]);
		if (start + 1 < length) printChar(document[start + 1]);
		if (start + 2 < length) printChar(document[start + 2]);

		System.out.print(" --- ");

		if (end - 2 >= 0) printChar(document[end - 2]);
		if (end - 1 >= 0) printChar(document[end - 1]);
		printChar(document[end]);
		if (end + 1 < length) printChar(document[end + 1]);
		if (end + 2 < length) printChar(document[end + 2]);

		System.out.println('<');
	}

	/** Display the start and end chars of a string. */
	protected static void displayString(String string) {
		final int length = string.length();

		System.out.print('>');
		if (length > 0) printChar(string.charAt(0));
		if (length > 1) printChar(string.charAt(1));
		if (length > 2) printChar(string.charAt(2));
		if (length > 3) printChar(string.charAt(3));

		System.out.print(" --- ");

		if (length > 4) printChar(string.charAt(length - 4));
		if (length > 5) printChar(string.charAt(length - 3));
		if (length > 6) printChar(string.charAt(length - 2));
		if (length > 7) printChar(string.charAt(length - 1));

		System.out.println('<');
	}

	/** Print a character to sysout. */
	protected static void printChar(final char c) {
		String out;
		switch (c) {
			case 9:
				out = "\\t";
				break;
			case 10:
				out = "\\n";
				break;
			default:
				out = String.valueOf(c);
		}
		System.out.print(out + ' ');
//		System.out.print(out + ":" + (int) c + " ");
	}

}
